<?php
//管理者画面ログインコントローラー

//画像認証の読み込み
require(__DIR__.'/vendor/mam_auth_image.php');
//モデルの読み込み
require(__DIR__.'/../model/cmsModelAdmin.php');
$cmsModel=new cmsModel;

$cmsModel->sessionSetParam();

if($cmsModel->isFirst()){//初回管理者パスワード設定の場合（ユーザーテーブルが空の場合）
  //初回管理者パスワード設定確認
  $err=false;
  $pass1='';
  $pass2='';
  if(array_key_exists('pass1',$_REQUEST)){
    $pass1=$_REQUEST['pass1'];
  }
  if(array_key_exists('pass2',$_REQUEST)){
    $pass2=$_REQUEST['pass2'];
  }
  if(!preg_match('/^[a-zA-Z0-9@_\-\.#]{8,16}$/',$pass1) || $pass1!=$pass2){
    $err=true;
  }
  if(!$err){
    //初回管理者パスワード登録
    $cmsModel->registAdminUser($pass1);
    //セッション開始[画像認証の有効期限付き]
    session_start();
    //ログインビューを表示する
    [$auth_char,$auth_img]=getCharImg();
    $_SESSION['input_char']=$auth_char;
    include(__DIR__.'/view/indexLogin.php');
  }else{
    //初回管理者パスワード設定ビュー
    include(__DIR__.'/view/indexFirstAdmin.php');
    exit;
  }
}else{
  //初回管理者パスワード設定済の場合（ユーザーテーブルに1行以上レコードがある場合）
  //セッション開始
  session_start();
  $id='';
  $pass='';
  $input_char='';
  if(array_key_exists('id',$_POST)){
    $id=$_POST['id'];
  }
  if(array_key_exists('pass',$_POST)){
    $pass=$_POST['pass'];
  }
  if(array_key_exists('input_char',$_POST)){
    $input_char=$_POST['input_char'];
  }
  //以下の値がある場合は、ログイン画面からログイン認証してきている
  if($id!='' && $pass!='' && $input_char!=''){
    //セッション変数に保存した正解の画像認証の値がある場合
    if(array_key_exists('input_char',$_SESSION)){
      //画像認証が正しい場合
      if($input_char==$_SESSION['input_char']){
        $uid=$cmsModel->loginCheck($id,$pass);
        if($uid>0){
          //ログイン成功時
          //ログインIDをセッション変数に設定
          $_SESSION['uid']=$uid;
          //管理者メニュー画面へ
          header('Location: ./menu.php');
          exit;
        }
      }
    }
  }
  //キャッシュを無効にする
  header('Cache-Control:no-cache,no-store,must-revalidate,max-age=0');
  header('Cache-Control:pre-check=0,post-check=0',false);
  header('Pragma:no-cache');
  //ログイン画面を表示する
  [$auth_char,$auth_img]=getCharImg();
  $_SESSION['input_char']=$auth_char;
  include(__DIR__.'/view/indexLogin.php');
}
