/*
  使い方：
  <script src="mamcalendar.js"></script>
  <input type="text" class="mamCalendar" placeholder="yyyy/mm/dd" />
  テキストボックスがアクティブになったら、カレンダーダイアログが表示されます
  Copyright 2021 mam
*/
function TMamCalendar(){
  'use strict';
  //----設定可能------
  this.delimiter="/";
  this.width='220px';
  this.size='10pt';
  this.BackgroundColor="#eee";
  this.HoverButtonColor="#aaa";
  this.WeekBackgroundColor="#ccc";
  this.CalendarBackgroundColor1="#fff";
  this.CalendarBackgroundColor2="#ccc";
  /*
  this.BackgroundColor="#acf";
  this.HoverButtonColor="#8ae";
  this.WeekBackgroundColor="#def";
  this.CalendarBackgroundColor1="#fff";
  this.CalendarBackgroundColor2="#bdf";
  */
  //------------------

  this.obj=null;//ポップアップフレーム全体
  let d=new Date();
  this.selected=d;
  this.y=d.getFullYear();
  this.m=d.getMonth()+1;
  this.d=d.getDate();
  this.inputs=[];
  this.target=null;
  this.calendarWeekDayBox=null;//曜日と日付ボックス
  this.elm_y=null;
  this.elm_m=null;
  this.init=function(){
    //スタイルシートの登録
    let style=document.createElement("style");
    document.head.appendChild(style);
    style.sheet.insertRule(
      '#mamCalendar{'+
        'color:#000;position:absolute;display:none;width:'+this.width+';'+
        'max-width:'+this.width+';min-width:'+this.width+';border:1px solid #000;'+
        'font-size:'+this.size+';background-color:#fff;letter-spacing:0px;'+
        'left:0px;top:100px;padding:0;margin:0;user-select: none;}'
    ,0);
    style.sheet.insertRule(
      '.mamCalendarControls{'+
      'display:flex;align-items:stretch;margin:0;padding:20px 0 0 0;width:100%;background-color:'+this.BackgroundColor+'}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate{'+
        'width:100%;text-align:center;font-size:1em;vertical-align:center;'+
        'padding:0;margin:0;background:linear-gradient('+
          '135deg,'+
          this.CalendarBackgroundColor1+' 0%,'+
          this.CalendarBackgroundColor1+' 20%,'+
          this.CalendarBackgroundColor2+' 100%);}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek{'+
        'display:flex;align-items:flex-end;align-content:stretch;'+
        'flex-wrap:nowrap;margin:0;padding:0;width:100%;background-color:transparent;}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek>div{'+
        'width:20%;height:2em;text-align:center;font-size:1em;'+
        'vertical-align:center;padding-top:0.5em;paddin-bottom:0;margin:0;background-color:transparent;}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek>div.week{background-color:'+this.WeekBackgroundColor+';}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek>div.mamCalendarToday{border:2px solid #6d6;}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek>div.mamCalendarSelected{background:#9f9;}'
    ,0);
    style.sheet.insertRule(
      '#mamCalendarDate>div.mamCalendarWeek>div.mamCalendarNormal:hover{background:#dfd;cursor:pointer;}'
    ,0);
    style.sheet.insertRule(
      '.mamCalendarBtn{'+
        'text-align:center;cursor:pointer;border:0;background-color:transparent;}'
    ,0);
    style.sheet.insertRule('.mamCalendarBtn:hover{border:0;background-color:'+this.HoverButtonColor+';}' ,0);

    let inp=document.querySelectorAll('input.mamCalendar');
    let i;
    for(i=0;i<inp.length;i++){
      if(inp[i].getAttribute('type')==null||inp[i].getAttribute('type')==""||inp[i].getAttribute('type').toLowerCase()=='text'){
        this.inputs.push(inp[i]);
      }
    }
    for(i=0;i<this.inputs.length;i++){
      this.inputs[i].setAttribute("maxlength",8+this.delimiter.length*2);
      //必要であればplaceholder属性設定
      //this.inputs[i].setAttribute("placeholder","yyyy"+this.delimiter+"mm"+this.delimiter+"dd");
      this.inputs[i].addEventListener("keydown",this.canOpen.bind(this));
      this.inputs[i].addEventListener("keyup",this.open.bind(this));
      this.inputs[i].addEventListener("click",this.open.bind(this));
      this.inputs[i].addEventListener("focus",this.open.bind(this));
    }

    this.obj=this.createFrameHTML();
    this.createInnerHTML();
    //閉じる設定(カレンダー以外をクリック時には閉じる
    //blurで処理したいがそれではうまくいかなかった
    document.body.addEventListener("click",this.otherClick.bind(this));
    document.documentElement.addEventListener("click",this.otherClick.bind(this));
  }
  this.createFrameHTML=function(){
    let obj=document.createElement("div");
    obj.setAttribute("id","mamCalendar");//ダイアログ
    let cal =  //操作部分
      '<div class="mamCalendarControls">'+
        '<div style="width:10%;" class="mamCalendarBtn" id="mamCalendarSubYear">'+
          '<svg style="width:0.8em;height:1.6em;margin:auto;" viewBox="0 0 10 20">'+
            '<polygon points="8,1 1,9 8,18" stroke="none" fill="#666" style="margin:auto;"></polygon>'+
          '</svg>'+
        '</div>'+
        '<div style="width:21%;text-align:center;font-weight:bold;font-size:1.2em;margin:0 auto;" id="mamCalendarYear">'+
          this.y+
        '</div>'+
        '<div style="width:9%;text-align:center;font-weight:bold;font-size:1.2em;margin:0 auto;">'+
          '年'+
        '</div>'+
        '<div style="width:10%;" class="mamCalendarBtn" id="mamCalendarAddYear">'+
          '<svg style="width:0.8em;height:1.6em;" viewBox="0 0 10 20">'+
            '<polygon points="1,1 9,9 1,18" stroke="none" fill="#666"></polygon>'+
          '</svg>'+
        '</div>'+
        '<div style="width:10%" class="mamCalendarBtn" id="mamCalendarSubMonth"">'+
          '<svg style="width:0.8em;height:1.6em;" viewBox="0 0 10 20">'+
            '<polygon points="9,1 1,9 9,18" stroke="none" fill="#666"></polygon>'+
          '</svg>'+
        '</div>'+
        '<div style="width:11%;text-align:center;font-weight:bold;font-size:1.2em;margin:0 auto;" id="mamCalendarMonth">'+
          this.m+
        '</div>'+
        '<div style="width:9%;text-align:center;font-weight:bold;font-size:1.2em;margin:0 auto;">'+
          '月'+
        '</div>'+
        '<div style="width:10%;" class="mamCalendarBtn" id="mamCalendarAddMonth">'+
          '<svg style="width:0.8em;height:1.6em;" viewBox="0 0 10 20">'+
            '<polygon points="1,1 9,9 1,18" stroke="none" fill="#666"></polygon>'+
          '</svg>'+
        '</div>'+
        '<div style="width:10%;" class="mamCalendarBtn" id="mamCalendarClose">'+
          '<svg style="width:1.6em;height:1.6em;margin:auto;padding:0;" viewBox="0 0 20 20">'+
            '<path d="M1,1 L18,18 M18,1 L1,18" stroke="#666" fill="none" stroke-width="4"></polygon>'+
          '</svg>'+
        '</div>'+
      '</div>';
    let dts=document.createElement("div");//曜日日付部分
    dts.setAttribute("id","mamCalendarDate");
    this.calendarWeekDayBox=dts;
    obj.innerHTML=cal;
    obj.appendChild(dts);
    document.body.appendChild(obj);
    this.elm_y=document.getElementById("mamCalendarYear");
    this.elm_m=document.getElementById("mamCalendarMonth");
    document.getElementById("mamCalendarSubYear").addEventListener("click",function(){this.AddYearMonth(-1,0);}.bind(this));
    document.getElementById("mamCalendarAddYear").addEventListener("click",function(){this.AddYearMonth(1,0);}.bind(this));
    document.getElementById("mamCalendarSubMonth").addEventListener("click",function(){this.AddYearMonth(0,-1);}.bind(this));
    document.getElementById("mamCalendarAddMonth").addEventListener("click",function(){this.AddYearMonth(0,1);}.bind(this));
    document.getElementById("mamCalendarClose").addEventListener("click",function(){this.close();}.bind(this));
    return obj;
  }
  this.createInnerHTML=function(){
    this.elm_y.innerHTML=this.y;
    this.elm_m.innerHTML=this.m;
    let calweek=
      '<div class="mamCalendarWeek">'+
        '<div class="week" style="color:#f00;">日</div><div class="week">月</div>'+
        '<div class="week">火</div><div class="week">水</div><div class="week">木</div>'+
        '<div class="week">金</div><div class="week" style="color:#44f;">土</div>'+
      '</div>';
    let arr=this.getCalendarArr();
    let i;
    for(i=0;i<arr.length;i++){
      if(i%7==0){
        calweek+='<div class="mamCalendarWeek">';
      }
      let mamclick='data-ymd="'+
        ('0000'+arr[i]["date"].getFullYear()).slice(-4)+this.delimiter+
        ('00'+(arr[i]["date"].getMonth()+1)).slice(-2)+this.delimiter+
        ('00'+arr[i]["date"].getDate()).slice(-2)+'" ';
      if(arr[i]["today"]){
        if(this.equalDate(arr[i]["date"],this.selected)){
          calweek+='<div class="mamCalendarNormal mamCalendarToday mamCalendarSelected mamCalendarDayClick" '+mamclick+'>';
        }else{
          calweek+='<div class="mamCalendarNormal mamCalendarToday mamCalendarDayClick" '+mamclick+'>';
        }
      }else{
        if(this.equalDate(arr[i]["date"],this.selected)){
          calweek+='<div class="mamCalendarNormal mamCalendarSelected mamCalendarDayClick" '+mamclick+'>';
        }else{
          calweek+='<div class="mamCalendarNormal mamCalendarDayClick" '+mamclick+'>';
        }
      }
      calweek+=arr[i]["date"].getDate()+'</div>';
      if(i%7==6){
        calweek+='</div>';
      }
    }
    this.calendarWeekDayBox.innerHTML=calweek;
    let inp=document.querySelectorAll(".mamCalendarDayClick");
    for(i=0;i<inp.length;i++){
      inp[i].addEventListener("click",this.selectDay.bind(this),true);
    }
  }
  this.getCalendarArr=function(){
    /*
      dayarr[0..34or41]['date'] Date
      dayarr[0..34or41]['week'] 0-6
      dayarr[0..34or41]['weekc'] red,blue,black
      dayarr[0..34or41]['today'] true,false
      dayarr[0..34or41]['monthf'] -1,0,1(前月,今月,来月)
    */
    let dayarr=[];
    if(this.y<1900){
      let dt=new Date();
      this.y=dt.getYear();
    }
    if(this.m<1||this.m>12){
      let dt=new Date();
      this.m=dt.getMonth();
    }else{
      this.m--;
    }
    //当月初
    let t_sdate=new Date(this.y,this.m,1);
    let t_sd=t_sdate.getDate();//日にち
    let t_se=t_sdate.getDay();//曜日 0:日～6:土
    //当月末
    let t_edate=new Date(t_sdate.getFullYear(), t_sdate.getMonth() + 1, 0)
    let t_ed=t_edate.getDate();//日にち
    let t_ee=t_edate.getDay();//曜日 0:日～6:土
    //今日
    let today=new Date();
    let i;
    //前月処理
    if(t_se!=0){
      for(i=t_se;i>0;i--){
        let dd={};
        let day=new Date(t_sdate.getFullYear(),t_sdate.getMonth(),t_sdate.getDate());
        day.setDate(day.getDate()-i);
        dd["date"]=day;
        dd["week"]=day.getDay();
        if(day.getDay()==0){dd["weekc"]="red";}else if(day.getDay()==6){dd["weekc"]="blue";}else{dd["weekc"]="black";}
        if(this.equalDate(day,today)){dd["today"]=true;}else{dd["today"]=false;}
        dd["monthf"]=-1;
        dayarr.push(dd);
      }
    }
    //当月処理
    for(i=1;i<=t_ed;i++){
      let dd={};
      let day=new Date(t_sdate.getFullYear(),t_sdate.getMonth(),t_sdate.getDate());
      day.setDate(day.getDate()+i-1);
      dd["date"]=day;
      dd["week"]=day.getDay();
      if(day.getDay()==0){dd["weekc"]="red";}else if(day.getDay()==6){dd["weekc"]="blue";}else{dd["weekc"]="black";}
      if(this.equalDate(day,today)){dd["today"]=true;}else{dd["today"]=false;}
      dd["monthf"]=0;
      dayarr.push(dd);
    }
    //翌月処理
    if(t_ee!=6){
      for(i=1;i<=(6-t_ee);i++){
        let dd={};
        let day=new Date(t_edate.getFullYear(),t_edate.getMonth(),t_edate.getDate());
        day.setDate(day.getDate()+i);
        dd["date"]=day;
        dd["week"]=day.getDay();
        if(day.getDay()==0){dd["weekc"]="red";}else if(day.getDay()==6){dd["weekc"]="blue";}else{dd["weekc"]="black";}
        if(this.equalDate(day,today)){dd["today"]=true;}else{dd["today"]=false;}
        dd["monthf"]=0;
        dayarr.push(dd);
      }
    }
    return dayarr;
  }
  //日付比較関数
  this.equalDate=function(date1, date2){
    let y1=date1.getFullYear();
    let m1=date1.getMonth();//0-11
    let d1=date1.getDate();
    let y2=date2.getFullYear();
    let m2=date2.getMonth();//0-11
    let d2=date2.getDate();
    if(y1==y2&&m1==m2&&d1==d2) {
      return true;
    }else{
      return false;
    }
  }
  //年月の増減
  this.AddYearMonth=function(addY,addM){
    let y=parseInt(document.getElementById('mamCalendarYear').innerHTML);
    let m=parseInt(document.getElementById('mamCalendarMonth').innerHTML);
    if(y>2100 || y<1901){
      y=(new Date()).getFullYear();
      m=(new Date()).getMonth()+1;
    }
    if(m>12 || m<1){
      m=(new Date()).getMonth()+1;
    }
    y+=addY;
    if(addM<0){m--;}
    if(addM>0){m++;}
    if(m<1){m=12;y--;}
    if(m>12){m=1;y++;}
    this.y=y;
    this.m=m;
    this.createInnerHTML();
  }
  //閉じる
  this.close=function(){
    this.obj.style.display="none";
  }
  //keydown
  this.canOpen=function(event){
    let k=event.key;
    if(k=="Tab"){this.close();return true;}
    if(k=="Shift"){return true;}
    if(k=="Escape"){event.target.value="";return true;}
    if(k=="ArrowLeft"||k=="ArrowRight"||k=="Delete"||k=="Backspace"||k=="Left"||k=="Right"||k=="Del"||
       k=="0"||k=="1"||k=="2"||k=="3"||k=="4"||k=="5"||k=="6"||k=="7"||k=="8"||k=="9"){return true;}
    if(k==this.delimiter){return true;}
    if(event.key=="c" && event.ctrlKey){return true;}
    if(event.key=="v" && event.ctrlKey){return true;}
    if(event.key=="x" && event.ctrlKey){return true;}
    if(event.type.match(/click/i)){return true;}
    event.stopPropagation();
    event.preventDefault();
  }
  //click,keyup
  this.open=function(event){
    this.target=event.target;
    let s="";
    if(this.target.value){
      s=this.target.value;
    }
    let dt=this.checkDate(s);
    this.y=dt[0];
    this.m=dt[1];
    this.d=dt[2];
    this.selected=new Date(this.y,this.m-1,this.d);

    let rect=event.target.getBoundingClientRect();
    this.obj.style.left=(rect.left+window.pageXOffset)+"px";
    this.obj.style.top=(rect.bottom+window.pageYOffset)+"px";
    this.createInnerHTML();
    this.obj.style.display='block';
  }
  //日付文字列を渡し配列を返す
  this.checkDate=function(s){
    let today=new Date();
    let y=today.getFullYear();
    let m=today.getMonth()+1;
    let d=today.getDate();
    if(s.match(/^[0-9]{8}$/)){
      y=parseInt(s.substr(0,4));
      m=parseInt(s.substr(4,2));
      d=parseInt(s.substr(6,2));
    }else if(s.match(/^[0-9]{6}$/)){
      y=parseInt(s.substr(0,4));
      m=parseInt(s.substr(4,2));
    }else if(s.match(/^[0-9]{4}$/)){
      y=parseInt(s.substr(0,4));
    }else if(this.delimiter!=''){
      let ymd=s.split(this.delimiter);
      if(ymd.length==3){
        y=parseInt(ymd[0]);
        if(isNaN(y)){y=today.getFullYear();}
        m=parseInt(ymd[1]);
        if(isNaN(m)){m=today.getMonth();}
        d=parseInt(ymd[2]);
        if(isNaN(d)){d=1;}
      }else if(ymd.length==2){
        y=parseInt(ymd[0]);
        if(isNaN(y)){y=today.getFullYear();}
        m=parseInt(ymd[1]);
        if(isNaN(m)){m=today.getMonth();}
      }else if(ymd.length==1){
        y=parseInt(ymd[0]);
        if(isNaN(y)){y=today.getFullYear();}
      }
    }
    if(y>2100 || y<1900){
      y=today.getFullYear();
      d=1;
    }
    if(m>12 || m<1){
      m=today.getMonth()+1;
      d=1;
    }
    if(d<=31 && d>=1){
      let dt = new Date(y,m-1,d);
      if(dt.getFullYear()!=y||(dt.getMonth()+1)!=m||dt.getDate()!=d){
        d=1;
      }
    }else{
      d=1;
    }
    return [y,m,d];
  }

  //カレンダーで日付選択された時
  this.selectDay=function(event){
    this.target.value=event.target.dataset.ymd;
    this.obj.style.display='none';
  }
  //blurで処理したいがそれではうまくいかなかった
  this.otherClick=function(event){
    if(event.target==this.target){return;}
    if(event.target==this.obj){return;}
    if(event.target.parentNode!=null){
      if(event.target.parentNode==this.obj){return;}
      if(event.target.parentNode.parentNode!=null){
        if(event.target.parentNode.parentNode==this.obj){return;}
        if(event.target.parentNode.parentNode.parentNode!=null){
        if(event.target.parentNode.parentNode.parentNode==this.obj){return;}
        if(event.target.parentNode.parentNode.parentNode.parentNode==this.obj){return;}
        }
      }
    }
    this.close();
  }
window.addEventListener("DOMContentLoaded",this.init.bind(this));
}
var MamCalendar=new TMamCalendar();