<?php
//管理者ログインビュー
if(count(debug_backtrace())==0){
  //このファイルがrequireやinclude経由ではなく単独で呼ばれた場合
  header('location: ../');
  exit;
}
?>
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta name="viewport" content="width=device-width,initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no">
  <meta charset="UTF-8">
  <title><?=$cmsModel::TITLE?>管理者パスワード変更</title>
  <link rel="stylesheet" type="text/css" href="./css/admin_base.css">
<script>
  window.addEventListener('load',function(){
    document.getElementById('sub').addEventListener('keydown',function(event){
      if(event.code=='Enter'||event.code=='Space'){
        document.getElementById('sub').click();
      }
    });
    document.getElementById('sub').addEventListener('click',function(){
      let pass1=document.getElementById('pass1');
      let pass2=document.getElementById('pass2');
      if(pass1.value!=pass2.value){
        document.getElementById('alert').innerHTML='設定するパスワードが一致しません';
        return false;
      }
      if(passCheck(pass1.value)==null){
        document.getElementById('alert').innerHTML='設定不可文字が含まれているか文字数が足りません';
        return false;
      }
      let ct=0;
      if(pass1.value.match(/[a-z]+/)){ct++;}
      if(pass1.value.match(/[A-Z]+/)){ct++;}
      if(pass1.value.match(/[0-9]+/)){ct++;}
      if(pass1.value.match(/[@_\-\.#]+/)){ct++;}
      if(ct<2){
        document.getElementById('alert').innerHTML='2種類以上の文字を含んでください';
        return false;
      }
      document.getElementById('fm').submit();
    });
  });
  function passCheck(pass){
    return pass.match(/^[a-zA-Z0-9@_\-\.#]{8,16}$/);
  }
</script>
</head>
<body>
  <header class="header">
    <div class="header_menu">
      <div><h1><?=$cmsModel::TITLE?> 管理</h1></div>
      <div>
        <a href="./menu.php" class="button min">メニュー</a>
        <a href="./logout.php" class="button min">ログアウトする</a>
      </div>
    </div>
    <div class="header_dt">
      <div class="dt">パスワード変更日：<?=$pdate?></div>
      <div class="dt">前回ログイン日：<?=$ndate?></div>
    </div>
  </header>
  <main class="main">
    <h1 class="title">管理者パスワードの変更</h3>
    <p class="explanation">
      管理者のパスワードを設定してください<br>
      使用できる文字の種類
    </p>
    <ol class="explanation">
      <li>「半角大文字アルファベット」</li>
      <li>「半角小文字アルファベット」</li>
      <li>「半角数字」</li>
      <li>「記号(@_-.#)」</li>
    </ol>
    <p class="explanation">
      8文字以上16文字以下、上記の文字を２種類以上入力してください。<br>
    </p>
    <form method="post" action="./changePasswordComp.php" id="fm" autocomplete="off">
      <input type="text" name="username" autocomplete="on" style="display:none;" />
      <label>
        <p>パスワード</p>
        <div>
          <input type="password" len="16" maxlength="16" pattern="^[a-zA-Z0-9@_\-.#]{8,16}$" required autocomplete="new-password" name="pass1" id="pass1" placeholder="8～16桁" /><br>
        </div>
      </label>
      <label>
        <p>パスワード<br>（再入力）</p>
        <div>
          <input type="password" len="16" maxlength="16" pattern="^[a-zA-Z0-9@_\-.#]{8,16}$" required autocomplete="new-password" name="pass2" id="pass2" placeholder="上記と同じものを入力" /><br>
        </div>
      </label>
      <a id="sub" class="button" tabindex="0">更新</a>
    </form>
    <div id="alert" style="color:red;"></div>
  </main>
</body>
</html>