<?php
//管理者 カテゴリ一覧ビュー
if(count(debug_backtrace())==0){
  //このファイルがrequireやinclude経由ではなく単独で呼ばれた場合
  header('location: ../');
  exit;
}
?>
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta name="viewport" content="width=device-width,initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no">
  <meta charset="UTF-8">
  <title><?=$cmsModel::TITLE?>カテゴリ編集</title>
  <link rel="stylesheet" type="text/css" href="./css/admin_base.css">
  <style>
    dl{margin:0;padding:2px;border:none;}
    dl>dt{
      margin-left:8px;
      margin-right:2px;
      margin-top:2px;
      margin-bottom:2px;
      padding:0px;
      font-size:18px;
      font-weight:bold;
      display:flex;
      align-items:center;
      background:#CCC;
    }
    dl>dt>div{display:inline-block;}
    dl>dd{
      margin-left:20px;margin-right:0px;margin-top:0px;margin-bottom:0px;
      padding:0px;
      font-size:16px;
      /*line-height:1em;*/
      display:flex;
      flex-wrap:nowrap;
      align-items:center;
      text-indent:0;
      position:relative;
    }
    dl>dd::before{position:absolute;top:0;left:0;bottom:0;border-left:1px solid #000;z-index:100;content:"";}
    dl>dd.el::before{transform:scale(100%,50%) translate(0,-50%);position:absolute;top:0;left:0;right:0;bottom:0;border-left:1px solid #000;z-index:100;content:"";}
    dl>dd::after{transform:translate(0,50%);position:absolute;top:0;left:0;bottom:0;width:10px;border-top:1px solid #000;z-index:100;content:"";}
    dl>dd>div{display:inline-block;}
    dl>dd>div>a{height:100%;}
    #inp{width:100%;min-width:310px;margin-bottom:20px;}
    #add_cate,#add_sub{display:none;border:1px solid #999;padding-bottom:30px;width:100%;}
    .sbmt{
      border-radius:4px;
    }
    .sbmt:hover{
      box-shadow:2px 2px 3px 0px rgba(0,0,0,0.4);
    }
    .sbmt:acvive{
      box-shadow:2px 2px 3px 0px rgba(0,0,0,0.4) inset;
    }
    input{
      border-radius:4px;
    }
  </style>
<script>
  var cate,sub;
  window.addEventListener('DOMContentLoaded',function(){
    cate=document.getElementById('add_cate');
    sub=document.getElementById('add_sub');
  });
  var list=<?=$subListJson?>;
  function add_cate(cid){
    let sbmt=document.querySelector('#add_cate .sbmt');
    let e_cid=document.querySelector('#cid');
    let e_pcid=document.querySelector('#pcid');
    let e_cname=document.querySelector('#cname');
    let e_corder=document.querySelector('#corder');
    let e_cdescription=document.querySelector('#cdescription');
    let title=document.querySelector('#cate_title');
    cate.style.display='block';
    sub.style.display='none';
    if(cid==0){
      sbmt.value='追加';
      e_cname.value='';
      e_cdescription.value='';
      e_corder.value=1;
      title.innerHTML='大カテゴリ追加';
    }else{
      sbmt.setAttribute('value','更新');
      let idx1=-1;
      for(let i=0;i<list.length;i++){
        if(list[i]['cid']==cid){
          idx1=i;
          break;
        }
      }
      e_cid.value=list[idx1]['cid'];
      e_cname.value=list[idx1]['_cname'];
      e_cdescription.value=list[idx1]['_cdescription'];
      e_corder.value=list[idx1]['corder'];
      title.innerHTML='大カテゴリ編集';
    }
    document.querySelector('#add_cate').scrollIntoView({behavior:'smooth', block:'end', inline:'end'});
  }
  function add_sub(cid,scid){
    let sbmt=document.querySelector('#add_sub .sbmt');
    let e_pcid=document.querySelector('#scpcid');
    let e_scid=document.querySelector('#scid');
    let e_scname=document.querySelector('#scname');
    let e_scorder=document.querySelector('#scorder');
    let e_scdescription=document.querySelector('#scdescription');
    let title=document.querySelector('#sub_title');
    e_scid.value=scid;
    cate.style.display='none';
    sub.style.display='block';
    for(i=0;i<e_pcid.options.length;i++){
      if(e_pcid.options[i].value==cid){
        e_pcid.selectedIndex=i;
      }
    }
    if(scid==0){
      e_scorder.value=1;
      e_scname.value='';
      e_scdescription.value='';
      sbmt.value='追加';
      title.innerHTML='小カテゴリ追加';
    }else{
      let idx1=e_pcid.selectedIndex;
      let idx2=-1;
      for(let i=0;i<list[idx1]['sub'].length;i++){
        if(list[idx1]['sub'][i]['scid']==scid){
          idx2=i;
          break;
        }
      }
      if(idx2!=-1){
        e_scorder.value=list[idx1]['sub'][idx2]['scorder'];
        e_scname.value=list[idx1]['sub'][idx2]['_scname'];
        e_scdescription.value=list[idx1]['sub'][idx2]['_scdescription'];
      }
      sbmt.value='更新';
      title.innerHTML='小カテゴリ編集';
    }
    document.querySelector('#add_sub').scrollIntoView({behavior:'smooth', block:'nearest', inline:'nearest'});
  }
</script>
</head>
<body>
  <header class="header">
    <div class="header_menu">
      <div><h1><?=$cmsModel::TITLE?> 管理</h1></div>
      <div>
        <a href="./menu.php" class="button min">メニュー</a>
        <a href="./logout.php" class="button min">ログアウトする</a>
      </div>
    </div>
  </header>
  <main class="main">

    <h1 class="title"><?=$cmsModel::TITLE?> カテゴリ編集</h2>
    <a class='button' href='javascript:void(0)' onclick='add_cate(0)'>大カテゴリ追加</a>
    <div style="width:100%;min-width:310px;">
      <?php
        if(count($subList)>0){
          echo "<dl class='cate'>\n";
          foreach($subList as $val){
            //大カテゴリ開始
            echo "  <dt>".
                 "    <div style='min-width:50px;'>".
                 "      <a class='button min' style='margin:0;' href='javascript:void(0)' onclick='add_cate(".$val['cid'].")'>編集</a>".
                 "      <a class='button min' style='margin:0;' href='javascript:void(0)' onclick='add_sub(".$val['cid'].",0)'>子追加</a>".
                 "    </div>\n".
                 "    <div>".$val['cname']."(".$val['corder'].")</div>\n".
                 "  </dt>\n";
            //小カテゴリ開始
            foreach($val["sub"] as $v){
              if(!is_null($v['scid'])){
                if($v['tree']=='└'){$class=" class='el'";}else{$class='';}
                echo "  <dd".$class.">\n".
                     "    <div><a class='button min' style='margin:0 0 0 10px' href='javascript:void(0)' onclick='add_sub(".$val['cid'].",".$v['scid'].")'>編集</a></div>\n".
                     "    <div>"/*.$v['tree']*/.$v['scname']."(".$v['scorder'].")</div>".
                     "  </dd>\n";
              }
            }
          }
          echo "</dl>\n";
        }
      ?>
    </div>
    <div id="inp">
      <form id="add_cate" class="act" action='updateInsertCategory.php' method='post'>
        <h4 id="cate_title">大カテゴリ追加</h4>
        <input type="hidden" name="cid" id="cid" value="0">
        <input type="hidden" name="pcid" id="pcid" value="0">
        大カテゴリ名：<br>
        <input type="text" value="" name="cname" id="cname" maxlength="40" autocomplete="off" required><br>
        メタディスクリプション：<br>
        <input type="text" value="" name="cdescription" id="cdescription" maxlength="100" autocomplete="off"><br>
        大カテゴリ表示順：<br>
        <input type="text" value="" name="corder" id="corder" maxlength="5" autocomplete="off" pattern="^[0-9]+$" required><br>
        <input type="submit" value="大カテゴリ追加" class="sbmt">
      </form>
      
      
      <form id="add_sub" action='updateInsertCategory.php' method='post'>
        <h4 id="sub_title">小カテゴリ追加</h4>
        大カテゴリ：<br>
        <select name="pcid" id="scpcid">
        <?php
          foreach($cate as $v){
            echo '<option value="'.$v['cid'].'">'.$v['cname'].'</option>';
          }
        ?>
        </select><br>
        <input type="hidden" name="cid" id="scid" value="0">
        小カテゴリ名：<br>
        <input type="text" value="" name="cname" id="scname" maxlength="40" autocomplete="off" required><br>
        メタディスクリプション：<br>
        <input type="text" value="" name="cdescription" id="scdescription" maxlength="100" autocomplete="off"><br>
        小カテゴリ表示順：<br>
        <input type="text" value="" name="corder" id="scorder" maxlength="5" autocomplete="off" pattern="^[0-9]+$" required><br>
        <input type="submit" value="小カテゴリ追加" class="sbmt">
      </form>
    </div>
  </main>
</body>
</html>
