<?php
//投稿新規編集 ビュー
if(count(debug_backtrace())==0){
  //このファイルがrequireやinclude経由ではなく単独で呼ばれた場合
  header('location: ../');
  exit;
}
?>
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta name="viewport" content="width=device-width,initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no">
  <title><?=$cmsModel::TITLE?>投稿編集</title>
  <link rel="stylesheet" type="text/css" href="./css/admin_base.css">
<style>
html,body{
  font-family:
    "Helvetica Neue", "Helvetica", "Hiragino Sans", "Hiragino Kaku Gothic ProN",
    "Arial", "Yu Gothic", "Meiryo", "MS PGothic", sans-serif;
  /*
  font-family:
    "Times New Roman", "YuMincho", "Hiragino Mincho ProN",
    "Yu Mincho", "MS PMincho", serif;
  */
  background:#fff;
}
  table.tableBlue{
    width:100%;
    border-collapse:collapse;
    border:none;
    border-spacing:0;
    table-layout:auto;
    margin:0;
    padding:4px;
    font-size:14px;
  }
  table.tableBlue tr>th{
    box-sizing:border-box;
    background: #7AF;
    border: solid 1px #ccc;
    color: #fff;
    margin:0;
    padding:10px;
    width:20%;
  }
  table.tableBlue tr>th>span{
    color:red;
  }
  table.tableBlue tr>td{
    box-sizing:border-box;
    border: solid 1px #ccc;
    color: #000;
    margin:0;
    padding:10px;
  }
  @media screen and (max-width:480px){
    /* 480以下 */
    body{
      margin:0;
      padding:0;
    }
    table.tableBlue tr>th{
      min-width:70px;
      font-size:11px;
    }
  }
</style>
<script src="./build/ckeditor.js"></script>
<script src="./js/mamcalendar.js"></script>
<script src="./js/mamtimepicker.js"></script>
<script>
var nmnum;//グローバルで宣言する
function img_onchange(e){
  if(e.files[0].size>(1024*512)){
    alert('ファイルサイズは512KB迄です');
    e.value='';
  }else{
    var reader=new FileReader();
    reader.onload=function(e){
      document.getElementById('img').src=e.target.result;
      document.getElementById('imgsrc').value=e.target.result;
    }
    reader.readAsDataURL(e.files[0]);
  }
}
function isDate(trueDate) {
  let arr=trueDate.split('/');
  if(arr.length!=3){return false;}
  var dt=new Date(arr[0], arr[1]-1, arr[2]);
  if (arr[0]==dt.getFullYear()&&arr[1]==('0'+(dt.getMonth()+1)).slice(-2)&&arr[2]==('0'+dt.getDate()).slice(-2)){
    return true;
  }else{
    return false;
  }
};

function sub(){
  let sdate1=document.getElementById('sdate1');
  let sdate2=document.getElementById('sdate2');
  let edate1=document.getElementById('edate1');
  let edate2=document.getElementById('edate2');
  let title=document.getElementById('title');
  let description=document.getElementById('description');
  let imgsrc=document.getElementById('imgsrc');
  let body=document.getElementById('body');
  let reg;
  if(!isDate(sdate1.value)){
    alert('開始日が不正です');
    return false;
  }
  if(edate1.value!=''&&!isDate(edate1.value)){
    alert('終了日が不正です');
    return false;
  }
  if(edate1.value==''){edate2.value='';}
  reg=/^[0-2]?[0-9]:[0-5]?[0-9]$/;
  if(!sdate2.value.match(reg)){
    alert('開始時刻が不正です');
    return false;
  }
  if(edate1.value!=''&&edate2.value!=''&&!edate2.value.match(reg)){
    alert('終了時刻が不正です');
    return false;
  }
  if(edate1.value!=''&&edate2.value==''){
    edate2.value='23:59';
  }
  if(edate1.value!=''&&(sdate1.value+sdate2.value)>(edate1.value+edate2.value)){
    alert('終了日より開始日が新しいです');
    return false;
  }
  if(title.value==''){
    alert('タイトルは必須です');
    return false;
  }
  /*
  if(imgsrc.value==''){
    alert('バナー画像がありません');
    return false;
  }
  */
  if (editor.getData().length == 0 ){
    alert('本文がありません');
    return false;
  }
  document.getElementById("fm").submit();
}
</script>
<script>
var subList=<?=$subListJson?>;
var cate=[];
var scate=[];
let cc=[];
let sc=[];

window.addEventListener("load",function(){
  document.getElementById("cid").addEventListener("change",function(){
    let elm=document.getElementById("scid");
    let idx=document.getElementById("cid").selectedIndex;
    for(let i=elm.options.length-1;i>=0;i--){
      elm.removeChild(elm.options[i]);
    }
    for(let j=0;j<subList[idx]["sub"].length;j++){
      let e=document.createElement("option");
      e.setAttribute("value",subList[idx]["sub"][j]["scid"]);
      e.innerHTML=subList[idx]["sub"][j]["scname"];
      elm.appendChild(e);
    }
  });


  //CKEditor5
  ClassicEditor
  .create( document.querySelector( '#body' ), {
    /* 自動テキスト変換(オートコレクト)を機能を切る 有効にしたい場合は typing項目をコメントアウトする */
    typing:{
      transformations:{
        include:[{from:'CKE', to:'CKEditor'}],
      }
    },
    toolbar: {
      items: [
        'heading',
        '|',
        'bold','italic','link','bulletedList','numberedList',
        '|',
        'outdent','indent','alignment',
        '|',
        'imageInsert',/*'imageUpload'*/,'blockQuote','insertTable',
        '|','horizontalLine',/*'todoList',*/
        
        '-',
        'fontFamily','fontColor','fontSize',
        '|',
        'fontBackgroundColor','highlight',
        '|',
        'strikethrough','underline','subscript','superscript',
        '|',
        'removeFormat',
        
        '-',
        'undo','redo','findAndReplace','sourceEditing',
        //'restrictedEditingException','code','codeBlock',
      ],
      shouldNotGroupWhenFull: true
    },
    language: 'ja',
    image: {
      toolbar: [
        'imageTextAlternative','imageStyle:inline',
        'imageStyle:block','imageStyle:side','linkImage'
      ]
    },
    table: {
      contentToolbar: [
        'tableColumn','tableRow',
        'mergeTableCells',
        'tableCellProperties','tableProperties'
      ]
    },
      licenseKey: '',
    } )
    .then( editor => {
      window.editor = editor;
      editor.setData('<?=addslashes($post['body'])?>');
  } )
  .catch( error => {
      console.error( 'Oops, something went wrong!' );
      console.error( 'Please, report the following error on https://github.com/ckeditor/ckeditor5/issues with the build id and the error stack trace:' );
      console.warn( 'Build id: kouh9binj3om-n6wbemw3na6l' );
      console.error( error );
  } );
});
</script>
</head>
<body>
  <header class="header">
    <div class="header_menu">
      <div><h1><?=$cmsModel::TITLE?>管理</h1></div>
      <div>
        <a href="./menu.php" class="button min">メニュー</a>
        <a href="./logout.php" class="button min">ログアウトする</a>
        <a href="./listPost.php" class="button min">管理者投稿一覧に戻る</a>
      </div>
    </div>
  </header>
  <main>
    <h1 class="title"><?=$pid==0?"新規投稿":"投稿編集"?></h3>

    <form method="post" action="updateInsertPostComp.php" id="fm">
      <table class="tableBlue">
        <tr>
          <th>公開／非公開<br><span>必須</span></th>
          <td>
            <input type="radio" name="visible" value="1" <?=($post['visible']==1)?'checked':'';?>>公開</label> 
            <label><input type="radio" name="visible" value="0" <?=($post['visible']==0)?'checked':'';?>>非公開</label>
          </td>
        </tr>
        <tr>
          <th>カテゴリ<br><span>必須</span></th>
          <td>
            <select id="cid" name="cid">
              <?php
                $idx=0;
                $cate_idx=0;
                foreach($subList as $val){
                  if($val['cid']==$post['cid']){
                    $sel=' selected';
                    $cate_idx=$idx;
                  }else{
                    $sel='';
                  }
                  $idx++;
                  echo "<option value='".$val['cid']."'".$sel.">".$val['cname']."</option>";
                }
              ?>
              ?>
            </select>
          </td>
        </tr>
        <tr>
          <th>サブカテゴリ<br><span>必須</span></th>
          <td>
            <select id="scid" name="scid">
              <?php
                foreach($subList[$cate_idx]["sub"] as $val){
                  if($val['scid']==$post['scid']){$sel=' selected';}else{$sel='';}
                  echo "<option value='".$val['scid']."'".$sel.">".$val['scname']."</option>";
                }
              ?>
              ?>
            </select>
          </td>
        </tr>
        <tr>
          <th>公開開始日時<br><span>必須</span></th>
          <td>
            <input type="text" id="sdate1" name="sdate1" class="mamCalendar" placeholder="yyyy/mm/dd" value="<?=$post['sdate1']?>" autocomplete="off">
            <input type="text" id="sdate2" name="sdate2" class="mamTimePicker" placeholder="hh:mm"  value="<?=$post['sdate2']?>" autocomplete="off">
          </td>
        </tr>
        <tr>
          <th>公開終了日時</th>
          <td>
            <input type="text" id="edate1" name="edate1" class="mamCalendar" placeholder="yyyy/mm/dd" value="<?=$post['edate1']?>" autocomplete="off">
            <input type="text" id="edate2" name="edate2" class="mamTimePicker" placeholder="hh:mm"  value="<?=$post['edate2']?>" autocomplete="off">
          </td>
        </tr>
        <tr>
          <th>タイトル：<br><span>必須</span></th>
          <td>
            <input type="text" size="32" maxlength="64" name="title" value="<?=$post['title']?>" id="title" autocomplete="off">
          </td>
        </tr>
        <tr>
          <th>メタディスクリプション</th>
          <td>
            <input type="text" style="width:100%;" maxlength="128" name="description" value="<?=$post['description']?>" autocomplete="off">
          </td>
        </tr>
        <tr>
          <th>バナー画像</th>
          <td>
            <input type="file" id="cms_image" name="cms_image" accept="image/png,image/jpeg,image/gif" onchange="img_onchange(this)" />
            <input type="hidden" id="imgsrc" name="imgsrc" value="<?=$post['img']?>"><br>
            <img id="img" style="max-width:300px;width:30%;min-width:200px;" src="<?=$post['img']?>">
          </td>
        </tr>
        <tr>
          <th>本文<br><span>必須</span></th>
          <td>
            <textarea name="body" cols="100" rows="10" id="body"></textarea>
          </td>
        </tr>
      </table>
      <br>
      投稿する：<input type="button" onclick="sub()" value="投稿">
      <input type="hidden" name="pid" id="pid" value="<?=$pid;?>">
    </form>
    <blockquote style="font-style:italic;font-size:10px;color:#666;border-left:4px solid #4946e6;padding-left:4px;">
      当ページはCKEditor5を使用しています<br />
      <p style="margin-left:8px;margin-top:4px;margin-bottom:4px;">
        Copyright (c) 2003-2021, CKSource Frederico Knabben. All rights reserved.<br>
        <!-- <a href="https://ckeditor.com/docs/ckeditor5/latest/builds/guides/support/license-and-legal.html#free-for-open-source"> -->
          https://ckeditor.com/docs/ckeditor5/latest/builds/guides/support/license-and-legal.html#free-for-open-source
        <!-- </a> -->
      </p>
    </blockquote>
  </main>
  <footer>
    <br>
  </footer>
</body>
</html>