<?php
if(count(debug_backtrace())==0){
  //このファイルがrequireやinclude経由ではなく単独で呼ばれた場合
  header('location: ../');
  exit;
}

abstract class cmsModelBase{
  //初期設定
  protected $dbServer='127.0.0.1'; //DBサーバーIPアドレス（初期設定必須）
  protected $dbName='db_cms';      //DB名（初期設定必須）
  protected $dbUser='user';        //DB接続ユーザー（初期設定必須）
  protected $dbPass='password';    //DB接続パスワード（初期設定必須）
  protected $postsPerPage=10;      //BO投稿検索画面での投稿の最大表示数（ページング）
  protected $postsPerSubCategory=4;//フロントトップの小カテゴリ毎に表示する投稿の最大数
  protected $favoriteShowCount=5;  //人気の(閲覧数が多い)投稿をいくつ表示するか
  protected $postsPerPageSub=10;   //フロント小カテゴリページ、検索結果ページで投稿一覧の最大表示数（ページング）
  const TITLE='SimpleCMS';      //タイトル（初期設定）
  protected $_salt='Salted__@=^~2021';//パスワードに付加するソルト値（必要なら初期設定、パスワード設定後変更不可）
  private $pdo;//PDO接続オブジェクト


  //★コンストラクタ
  public function __construct(){
    //データベース接続
    date_default_timezone_set("Asia/Tokyo");
    $this->pdo=new PDO('mysql:dbname='.$this->dbName.';host='.$this->dbServer, $this->dbUser, $this->dbPass);
      ini_set('display_errors', 0);
  }

  //★汎用 与えられたSQL文($sql)とパラメータ($param)を実行し結果を返す
  protected function execSQL($sql,$param=[]){
    $this->pdo->beginTransaction();
    $stmt=$this->pdo->prepare($sql);
    $res=$stmt->execute($param);
    $ret=[];
    if($res){
      $this->pdo->commit();
      while($row=$stmt->fetch(PDO::FETCH_ASSOC)){
        $ret[]=$row;
      }
    }else{
      $this->pdo->rollBack();
    }
    return $ret;
  }

  //★BOとFront 初回ログイン（ユーザー無し）か確認する
  public function isFirst(){
    $sql='SELECT COUNT(uid) AS ct FROM tm_user';
    $ct=$this->execSQL($sql,[])[0]['ct'];
    if($ct==0){return true;}else{return false;}
  }
  
}